<?php

namespace Drupal\month_year\Plugin\Field\FieldFormatter;

use Drupal\Core\Datetime\DateHelper;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'year_month_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "year_month_formatter",
 *   label = @Translation("Month Year formatter"),
 *   field_types = {
 *     "year_month"
 *   }
 * )
 */
class YearMonthFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {

    $months = DateHelper::monthNamesAbbr(TRUE);

    $element = [];

    foreach ($items as $delta => $item) {
      list($year, $month) = explode('-', $item->value);
      $month = $month ? $months[(integer) $month] : '';
      $element[$delta] = ['#markup' => $this->t("$month $year")];
    }
    return $element;
  }

}
